Index: sasmodels/models/elliptical_cylinder.c
===================================================================
--- sasmodels/models/elliptical_cylinder.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/elliptical_cylinder.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -6,158 +6,76 @@
 
 
-double _elliptical_cylinder_kernel(double q, double radius_minor, double r_ratio, double theta);
-
-double _elliptical_cylinder_kernel(double q, double radius_minor, double r_ratio, double theta)
-{
-    // This is the function LAMBDA1^2 in Feigin's notation
-    // q is the q-value for the calculation (1/A)
-    // radius_minor is the transformed radius"a" in Feigin's notation
-    // r_ratio is the ratio (major radius)/(minor radius) of the Ellipsoid [=] ---
-    // theta is the dummy variable of the integration
-
-    double retval,arg;
-
-    arg = q*radius_minor*sqrt((1.0+r_ratio*r_ratio)/2+(1.0-r_ratio*r_ratio)*cos(theta)/2);
-    //retval = 2.0*J1(arg)/arg;
-    retval = sas_J1c(arg);
-    return retval*retval ;
-}
-
-
-double form_volume(double radius_minor, double r_ratio, double length)
+double
+form_volume(double radius_minor, double r_ratio, double length)
 {
     return M_PI * radius_minor * radius_minor * r_ratio * length;
 }
 
-double Iq(double q, double radius_minor, double r_ratio, double length,
-          double sld, double solvent_sld) {
+double
+Iq(double q, double radius_minor, double r_ratio, double length,
+   double sld, double solvent_sld)
+{
+    // orientational average limits
+    const double va = 0.0;
+    const double vb = 1.0;
+    // inner integral limits
+    const double vaj=0.0;
+    const double vbj=M_PI;
 
-    const int nordi=76; //order of integration
-    const int nordj=20;
-    double va,vb;       //upper and lower integration limits
-    double summ,zi,yyy,answer;         //running tally of integration
-    double summj,vaj,vbj,zij,arg,si;            //for the inner integration
-
-    // orientational average limits
-    va = 0.0;
-    vb = 1.0;
-    // inner integral limits
-    vaj=0.0;
-    vbj=M_PI;
+    const double radius_major = r_ratio * radius_minor;
+    const double rA = 0.5*(square(radius_major) + square(radius_minor));
+    const double rB = 0.5*(square(radius_major) - square(radius_minor));
 
     //initialize integral
-    summ = 0.0;
-
-    const double delrho = sld - solvent_sld;
-
-    for(int i=0;i<nordi;i++) {
+    double outer_sum = 0.0;
+    for(int i=0;i<76;i++) {
         //setup inner integral over the ellipsoidal cross-section
-        summj=0;
-        zi = ( Gauss76Z[i]*(vb-va) + va + vb )/2.0;     //the "x" dummy
-        arg = radius_minor*sqrt(1.0-zi*zi);
-        for(int j=0;j<nordj;j++) {
+        const double cos_val = ( Gauss76Z[i]*(vb-va) + va + vb )/2.0;
+        const double sin_val = sqrt(1.0 - cos_val*cos_val);
+        //const double arg = radius_minor*sin_val;
+        double inner_sum=0;
+        for(int j=0;j<20;j++) {
             //20 gauss points for the inner integral
-            zij = ( Gauss20Z[j]*(vbj-vaj) + vaj + vbj )/2.0;        //the "y" dummy
-            yyy = Gauss20Wt[j] * _elliptical_cylinder_kernel(q, arg, r_ratio, zij);
-            summj += yyy;
+            const double theta = ( Gauss20Z[j]*(vbj-vaj) + vaj + vbj )/2.0;
+            const double r = sin_val*sqrt(rA - rB*cos(theta));
+            const double be = sas_2J1x_x(q*r);
+            inner_sum += Gauss20Wt[j] * be * be;
         }
         //now calculate the value of the inner integral
-        answer = (vbj-vaj)/2.0*summj;
+        inner_sum *= 0.5*(vbj-vaj);
 
         //now calculate outer integral
-        arg = q*length*zi/2.0;
-        si = square(sinc(arg));
-        yyy = Gauss76Wt[i] * answer * si;
-        summ += yyy;
+        const double si = sas_sinx_x(q*0.5*length*cos_val);
+        outer_sum += Gauss76Wt[i] * inner_sum * si * si;
     }
+    outer_sum *= 0.5*(vb-va);
 
     //divide integral by Pi
-    answer = (vb-va)/2.0*summ/M_PI;
-    // Multiply by contrast^2
-    answer *= delrho*delrho;
+    const double form = outer_sum/M_PI;
 
+    // scale by contrast and volume, and convert to to 1/cm units
     const double vol = form_volume(radius_minor, r_ratio, length);
-    return answer*vol*vol*1.0e-4;
+    const double delrho = sld - solvent_sld;
+    return 1.0e-4*square(delrho*vol)*form;
 }
 
 
-double Iqxy(double qx, double qy, double radius_minor, double r_ratio, double length,
-            double sld, double solvent_sld, double theta, double phi, double psi) {
-    const double _theta = theta * M_PI / 180.0;
-    const double _phi = phi * M_PI / 180.0;
-    const double _psi = psi * M_PI / 180.0;
-    const double q = sqrt(qx*qx+qy*qy);
-    const double q_x = qx/q;
-    const double q_y = qy/q;
+double
+Iqxy(double qx, double qy,
+     double radius_minor, double r_ratio, double length,
+     double sld, double solvent_sld,
+     double theta, double phi, double psi)
+{
+    double q, cos_val, cos_mu, cos_nu;
+    ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, q, cos_val, cos_mu, cos_nu);
 
-    //Cylinder orientation
-    double cyl_x = cos(_theta) * cos(_phi);
-    double cyl_y = sin(_theta);
-
-    //cyl_z = -cos(_theta) * sin(_phi);
-
-    // q vector
-    //q_z = 0;
-
-    // Note: cos(alpha) = 0 and 1 will get an
-    // undefined value from CylKernel
-    //alpha = acos( cos_val );
-
-    //ellipse orientation:
-    // the elliptical corss section was transformed and projected
-    // into the detector plane already through sin(alpha)and furthermore psi remains as same
-    // on the detector plane.
-    // So, all we need is to calculate the angle (nu) of the minor axis of the ellipse wrt
-    // the wave vector q.
-
-    //x- y- component on the detector plane.
-    const double ella_x =  -cos(_phi)*sin(_psi) * sin(_theta)+sin(_phi)*cos(_psi);
-    const double ella_y =  sin(_psi)*cos(_theta);
-    const double ellb_x =  -sin(_theta)*cos(_psi)*cos(_phi)-sin(_psi)*sin(_phi);
-    const double ellb_y =  cos(_theta)*cos(_psi);
-
-    // Compute the angle btw vector q and the
-    // axis of the cylinder
-    double cos_val = cyl_x*q_x + cyl_y*q_y;// + cyl_z*q_z;
-
-    // calculate the axis of the ellipse wrt q-coord.
-    double cos_nu = ella_x*q_x + ella_y*q_y;
-    double cos_mu = ellb_x*q_x + ellb_y*q_y;
-
-    // The following test should always pass
-    if (fabs(cos_val)>1.0) {
-      //printf("cyl_ana_2D: Unexpected error: cos(alpha)>1\n");
-      cos_val = 1.0;
-    }
-    if (fabs(cos_nu)>1.0) {
-      //printf("cyl_ana_2D: Unexpected error: cos(nu)>1\n");
-      cos_nu = 1.0;
-    }
-    if (fabs(cos_mu)>1.0) {
-      //printf("cyl_ana_2D: Unexpected error: cos(nu)>1\n");
-      cos_mu = 1.0;
-    }
-
-    const double r_major = r_ratio * radius_minor;
-    const double qr = q*sqrt( r_major*r_major*cos_nu*cos_nu + radius_minor*radius_minor*cos_mu*cos_mu );
-    const double qL = q*length*cos_val/2.0;
-
-    double Be;
-    if (qr==0){
-      Be = 0.5;
-    }else{
-      //Be = NR_BessJ1(qr)/qr;
-      Be = 0.5*sas_J1c(qr);
-    }
-
-    double Si;
-    if (qL==0){
-      Si = 1.0;
-    }else{
-      Si = sin(qL)/qL;
-    }
-
-    const double k = 2.0 * Be * Si;
+    // Compute:  r = sqrt((radius_major*cos_nu)^2 + (radius_minor*cos_mu)^2)
+    // Given:    radius_major = r_ratio * radius_minor
+    const double r = radius_minor*sqrt(square(r_ratio*cos_nu) + cos_mu*cos_mu);
+    const double be = sas_2J1x_x(q*r);
+    const double si = sas_sinx_x(q*0.5*length*cos_val);
+    const double Aq = be * si;
+    const double delrho = sld - solvent_sld;
     const double vol = form_volume(radius_minor, r_ratio, length);
-    return (sld - solvent_sld) * (sld - solvent_sld) * k * k *vol*vol*1.0e-4;
+    return 1.0e-4 * square(delrho * vol * Aq);
 }
Index: sasmodels/models/elliptical_cylinder.py
===================================================================
--- sasmodels/models/elliptical_cylinder.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/elliptical_cylinder.py	(revision fcb33e4672814b4a8fe1ee865d430090b5fc03e6)
@@ -20,5 +20,5 @@
 
     I(\vec q)=\frac{1}{V_\text{cyl}}\int{d\psi}\int{d\phi}\int{
-        p(\theta,\phi,\psi)F^2(\vec q,\alpha,\psi)\sin(\theta)d\theta}
+        p(\theta,\phi,\psi)F^2(\vec q,\alpha,\psi)\sin(\alpha)d\alpha}
 
 with the functions
@@ -26,5 +26,5 @@
 .. math::
 
-    F(\vec q,\alpha,\psi) = 2\frac{J_1(a)\sin(b)}{ab}
+    F(q,\alpha,\psi) = 2\frac{J_1(a)\sin(b)}{ab}
 
 where
@@ -32,10 +32,12 @@
 .. math::
 
-    a &= \vec q\sin(\alpha)\left[
-        r^2_\text{major}\sin^2(\psi)+r^2_\text{minor}\cos(\psi) \right]^{1/2}
+    a = qr'\sin(\alpha)
+    
+    b = q\frac{L}{2}\cos(\alpha)
+    
+    r'=\frac{r_{minor}}{\sqrt{2}}\sqrt{(1+\nu^{2}) + (1-\nu^{2})cos(\psi)}
 
-    b &= \vec q\frac{L}{2}\cos(\alpha)
 
-and the angle $\Psi$ is defined as the orientation of the major axis of the
+and the angle $\psi$ is defined as the orientation of the major axis of the
 ellipse with respect to the vector $\vec q$. The angle $\alpha$ is the angle
 between the axis of the cylinder and $\vec q$.
@@ -95,5 +97,13 @@
 
 L A Feigin and D I Svergun, *Structure Analysis by Small-Angle X-Ray and
-Neutron Scattering*, Plenum, New York, (1987)
+Neutron Scattering*, Plenum, New York, (1987) [see table 3.4]
+
+Authorship and Verification
+----------------------------
+
+* **Author:**
+* **Last Modified by:** 
+* **Last Reviewed by:**  Richard Heenan - corrected equation in docs **Date:** December 21, 2016
+
 """
 
Index: sasmodels/models/fcc_paracrystal.c
===================================================================
--- sasmodels/models/fcc_paracrystal.c	(revision 0bef47b278e819df7ea6b572375dd7bc9607227e)
+++ sasmodels/models/fcc_paracrystal.c	(revision 4962519cc1910422a467e4f643dba223623e0e09)
@@ -32,5 +32,5 @@
 
 	const double temp10 = exp((-1.0/8.0)*temp1*((temp7*temp7)+(temp8*temp8)+(temp9*temp9)));
-	result = pow((1.0-(temp10*temp10)),3)*temp6
+	result = cube(1.0-(temp10*temp10))*temp6
 	    / ( (1.0 - 2.0*temp10*cos(0.5*temp3*temp7) + temp10*temp10)
 	      * (1.0 - 2.0*temp10*cos(0.5*temp3*temp8) + temp10*temp10)
@@ -85,86 +85,28 @@
 }
 
+double Iqxy(double qx, double qy,
+    double dnn, double d_factor, double radius,
+    double sld, double solvent_sld,
+    double theta, double phi, double psi)
+{
+    double q, cos_a1, cos_a2, cos_a3;
+    ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, q, cos_a3, cos_a2, cos_a1);
 
-double Iqxy(double qx, double qy, double dnn,
-    double d_factor, double radius,double sld, double solvent_sld,
-    double theta, double phi, double psi){
+    const double a1 = cos_a2 + cos_a3;
+    const double a2 = cos_a3 + cos_a1;
+    const double a3 = cos_a2 + cos_a1;
+    const double qd = 0.5*q*dnn;
+    const double arg = 0.5*square(qd*d_factor)*(a1*a1 + a2*a2 + a3*a3);
+    const double tanh_qd = tanh(arg);
+    const double cosh_qd = cosh(arg);
+    const double Zq = tanh_qd/(1. - cos(qd*a1)/cosh_qd)
+                    * tanh_qd/(1. - cos(qd*a2)/cosh_qd)
+                    * tanh_qd/(1. - cos(qd*a3)/cosh_qd);
 
-  double b3_x, b3_y, b1_x, b1_y, b2_x, b2_y; //b3_z,
-  // double q_z;
-  double cos_val_b3, cos_val_b2, cos_val_b1;
-  double a1_dot_q, a2_dot_q,a3_dot_q;
-  double answer;
-  double Zq, Fkq, Fkq_2;
+    //if (isnan(Zq)) printf("q:(%g,%g) qd: %g a1: %g a2: %g a3: %g arg: %g\n", qx, qy, qd, a1, a2, a3, arg);
 
-  //convert to q and make scaled values
-  double q = sqrt(qx*qx+qy*qy);
-  double q_x = qx/q;
-  double q_y = qy/q;
-
-  //convert angle degree to radian
-  theta = theta * M_PI_180;
-  phi = phi * M_PI_180;
-  psi = psi * M_PI_180;
-
-  const double Da = d_factor*dnn;
-  const double s1 = dnn/sqrt(0.75);
-
-
-  //the occupied volume of the lattice
-  const double latticescale = 2.0*sphere_volume(radius/s1);
-  // q vector
-  // q_z = 0.0; // for SANS; assuming qz is negligible
-  /// Angles here are respect to detector coordinate
-  ///  instead of against q coordinate(PRB 36(46), 3(6), 1754(3854))
-    // b3 axis orientation
-    b3_x = cos(theta) * cos(phi);
-    b3_y = sin(theta);
-    //b3_z = -cos(theta) * sin(phi);
-    cos_val_b3 =  b3_x*q_x + b3_y*q_y;// + b3_z*q_z;
-
-    //alpha = acos(cos_val_b3);
-    // b1 axis orientation
-    b1_x = -cos(phi)*sin(psi) * sin(theta)+sin(phi)*cos(psi);
-    b1_y = sin(psi)*cos(theta);
-    cos_val_b1 = b1_x*q_x + b1_y*q_y;
-    // b2 axis orientation
-    b2_x = -sin(theta)*cos(psi)*cos(phi)-sin(psi)*sin(phi);
-  	b2_y = cos(theta)*cos(psi);
-    cos_val_b2 = b2_x*q_x + b2_y*q_y;
-
-    // The following test should always pass
-    if (fabs(cos_val_b3)>1.0) {
-      //printf("FCC_ana_2D: Unexpected error: cos()>1\n");
-      cos_val_b3 = 1.0;
-    }
-    if (fabs(cos_val_b2)>1.0) {
-      //printf("FCC_ana_2D: Unexpected error: cos()>1\n");
-      cos_val_b2 = 1.0;
-    }
-    if (fabs(cos_val_b1)>1.0) {
-      //printf("FCC_ana_2D: Unexpected error: cos()>1\n");
-      cos_val_b1 = 1.0;
-    }
-    // Compute the angle btw vector q and the a3 axis
-    a3_dot_q = 0.5*dnn*q*(cos_val_b2+cos_val_b1-cos_val_b3);
-
-    // a1 axis
-    a1_dot_q = 0.5*dnn*q*(cos_val_b3+cos_val_b2-cos_val_b1);
-
-    // a2 axis
-    a2_dot_q = 0.5*dnn*q*(cos_val_b3+cos_val_b1-cos_val_b2);
-
-
-    // Get Fkq and Fkq_2
-    Fkq = exp(-0.5*pow(Da/dnn,2.0)*(a1_dot_q*a1_dot_q+a2_dot_q*a2_dot_q+a3_dot_q*a3_dot_q));
-    Fkq_2 = Fkq*Fkq;
-    // Call Zq=Z1*Z2*Z3
-    Zq = (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a1_dot_q)+Fkq_2);
-    Zq *= (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a2_dot_q)+Fkq_2);
-    Zq *= (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a3_dot_q)+Fkq_2);
-
-  // Use SphereForm directly from libigor
-  answer = sphere_form(q,radius,sld,solvent_sld)*Zq*latticescale;
-
-  return answer;
- }
+    const double Fq = sphere_form(q,radius,sld,solvent_sld)*Zq;
+    //the occupied volume of the lattice
+    const double lattice_scale = 4.0*sphere_volume(M_SQRT1_2*radius/dnn);
+    return lattice_scale * Fq;
+}
Index: sasmodels/models/fcc_paracrystal.py
===================================================================
--- sasmodels/models/fcc_paracrystal.py	(revision 0bef47b278e819df7ea6b572375dd7bc9607227e)
+++ sasmodels/models/fcc_paracrystal.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -116,5 +116,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/gauss150.c", "lib/sphere_form.c", "fcc_paracrystal.c"]
+source = ["lib/sas_3j1x_x.c", "lib/gauss150.c", "lib/sphere_form.c", "fcc_paracrystal.c"]
 
 # parameters for demo
Index: sasmodels/models/flexible_cylinder.c
===================================================================
--- sasmodels/models/flexible_cylinder.c	(revision e6408d049d3598925e345d8adec1cdb0bb0c6adb)
+++ sasmodels/models/flexible_cylinder.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -14,5 +14,5 @@
 {
     const double contrast = sld - solvent_sld;
-    const double cross_section = sas_J1c(q*radius);
+    const double cross_section = sas_2J1x_x(q*radius);
     const double volume = M_PI*radius*radius*length;
     const double flex = Sk_WR(q, length, kuhn_length);
Index: sasmodels/models/flexible_cylinder_elliptical.c
===================================================================
--- sasmodels/models/flexible_cylinder_elliptical.c	(revision b66d38efa49109d61182ada21c4f30e06f75d4cd)
+++ sasmodels/models/flexible_cylinder_elliptical.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -2,6 +2,4 @@
 double Iq(double q, double length, double kuhn_length, double radius,
           double axis_ratio, double sld, double solvent_sld);
-double Iqxy(double qx, double qy, double length, double kuhn_length,
-            double radius, double axis_ratio, double sld, double solvent_sld);
 double flexible_cylinder_ex_kernel(double q, double length, double kuhn_length,
                                 double radius, double axis_ratio, double sld,
@@ -17,18 +15,16 @@
 elliptical_crosssection(double q, double a, double b)
 {
-    double summ=0.0;
+    double sum=0.0;
 
     for(int i=0;i<N_POINTS_76;i++) {
-        double zi = ( Gauss76Z[i] + 1.0 )*M_PI/4.0;
+        const double zi = ( Gauss76Z[i] + 1.0 )*M_PI_4;
         double sn, cn;
         SINCOS(zi, sn, cn);
-        double arg = q*sqrt(a*a*sn*sn+b*b*cn*cn);
-        double yyy = pow((double)sas_J1c(arg),2);
-        yyy *= Gauss76Wt[i];
-        summ += yyy;
+        const double arg = q*sqrt(a*a*sn*sn + b*b*cn*cn);
+        const double yyy = sas_2J1x_x(arg);
+        sum += Gauss76Wt[i] * yyy * yyy;
     }
-
-    summ /= 2.0;
-    return(summ);
+    sum *= 0.5;
+    return(sum);
 
 }
@@ -77,22 +73,2 @@
 }
 
-double Iqxy(double qx, double qy,
-            double length,
-            double kuhn_length,
-            double radius,
-            double axis_ratio,
-            double sld,
-            double solvent_sld)
-{
-    double q;
-    q = sqrt(qx*qx+qy*qy);
-    double result = flexible_cylinder_ex_kernel(q,
-                    length,
-                    kuhn_length,
-                    radius,
-                    axis_ratio,
-                    sld,
-                    solvent_sld);
-
-    return result;
-}
Index: sasmodels/models/fractal.c
===================================================================
--- sasmodels/models/fractal.c	(revision 2c74c11fc4544381ecf9949bd1618c67ff624c6d)
+++ sasmodels/models/fractal.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -1,54 +1,25 @@
-double Iq(double q,
-          double volfraction,
-          double radius,
-          double fractal_dim,
-          double cor_length,
-          double sld_block,
-          double sld_solvent);
+#define INVALID(p) (p.fractal_dim < 0.0)
 
-double Iq(double q,
-          double volfraction,
-          double radius,
-          double fractal_dim,
-          double cor_length,
-          double sld_block,
-          double sld_solvent)
+static double
+Iq(double q,
+   double volfraction,
+   double radius,
+   double fractal_dim,
+   double cor_length,
+   double sld_block,
+   double sld_solvent)
 {
-    double qr,r0,Df,corr,phi,sldp,sldm;
-    double pq,sq,inten;
-    
-     // Actively check the argument - needed for mass fractal - is it needie
-     //here?
-    if (fractal_dim <= 0.0){
-       return 0.0;
-    }
-   
-    phi = volfraction;        // volume fraction of building block spheres...
-    r0 = radius;     //  radius of building block
-    Df = fractal_dim;     //  fractal dimension
-    corr = cor_length;       //  correlation length of fractal-like aggregates
-    sldp = sld_block;       // SLD of building block
-    sldm = sld_solvent;       // SLD of matrix or solution
- 
-     qr=q*r0;
-    
+    const double sq = fractal_sq(q, radius, fractal_dim, cor_length);
+
     //calculate P(q) for the spherical subunits
-    pq = phi*M_4PI_3*r0*r0*r0*(sldp-sldm)*(sldp-sldm)*sph_j1c(qr)*sph_j1c(qr);
-    
-    //calculate S(q)
-    sq = Df*sas_gamma(Df-1.0)*sin((Df-1.0)*atan(q*corr));
-    sq /= pow(qr,Df) * pow((1.0 + 1.0/(q*corr)/(q*corr)),((Df-1.0)/2.0));
-    sq += 1.0;
-    
-    //combine, scale to units cm-1 sr-1 (assuming data on absolute scale)
-    //and return
-    inten = pq*sq;
-    // convert I(1/A) to (1/cm)
-    inten *= 1.0e8;
-    //convert rho^2 in 10^-6 1/A to 1/A
-    inten *= 1.0e-12;    
-    
-    
-    return(inten);
+    const double V = M_4PI_3*cube(radius);
+    const double pq = V * square((sld_block-sld_solvent)*sas_3j1x_x(q*radius));
+
+    // scale to units cm-1 sr-1 (assuming data on absolute scale)
+    //    convert I(1/A) to (1/cm)  => 1e8 * I(q)
+    //    convert rho^2 in 10^-6 1/A to 1/A  => 1e-12 * I(q)
+    //    combined: 1e-4 * I(q)
+
+    return 1.e-4 * volfraction * sq * pq;
 }
 
Index: sasmodels/models/fractal.py
===================================================================
--- sasmodels/models/fractal.py	(revision d1cfa86b03d71f574114b242dc91eefade357ba2)
+++ sasmodels/models/fractal.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -97,5 +97,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/sas_gamma.c", "fractal.c"]
+source = ["lib/sas_3j1x_x.c", "lib/sas_gamma.c", "lib/fractal_sq.c", "fractal.c"]
 
 demo = dict(volfraction=0.05,
Index: sasmodels/models/fractal_core_shell.c
===================================================================
--- sasmodels/models/fractal_core_shell.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/fractal_core_shell.c	(revision bdd08df2ecb671a5503c0699fe24a2bc3f2a8a7a)
@@ -1,47 +1,28 @@
-double form_volume(double radius, double thickness);
-
-double Iq(double q,
-          double radius,
-          double thickness,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld,
-          double volfraction,
-          double fractal_dim,
-          double cor_length);
-
-double form_volume(double radius, double thickness)
+static double
+form_volume(double radius, double thickness)
 {
-    return 4.0 * M_PI / 3.0 * pow((radius + thickness), 3);
+    return M_4PI_3 * cube(radius + thickness);
 }
 
-double Iq(double q,
-          double radius,
-          double thickness,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld,
-          double volfraction,
-          double fractal_dim,
-          double cor_length) {
+static double
+Iq(double q,
+   double radius,
+   double thickness,
+   double core_sld,
+   double shell_sld,
+   double solvent_sld,
+   double volfraction,
+   double fractal_dim,
+   double cor_length)
+{
+    //The radius for the building block of the core shell particle that is 
+    //needed by the Teixeira fractal S(q) is the radius of the whole particle.
+    const double cs_radius = radius + thickness;
+    const double sq = fractal_sq(q, cs_radius, fractal_dim, cor_length);
+    const double pq = core_shell_kernel(q, radius, thickness,
+                                        core_sld, shell_sld, solvent_sld);
 
-
-   double intensity = core_shell_kernel(q,
-                              radius,
-                              thickness,
-                              core_sld,
-                              shell_sld,
-                              solvent_sld);
-    //calculate S(q)
-    double frac_1 = fractal_dim-1.0;
-    double qr = q*radius;
-
-    double t1 = fractal_dim*sas_gamma(frac_1)*sin(frac_1*atan(q*cor_length));
-    double t2 = (1.0 + 1.0/(q*cor_length)/(q*cor_length));
-    double t3 = pow(qr, fractal_dim) * pow(t2, (frac_1/2.0));
-    double sq = t1/t3;
-    sq += 1.0;
-
-    return sq*intensity*volfraction;
+    // Note: core_shell_kernel already performs the 1e-4 unit conversion
+    return volfraction * sq * pq;
 }
 
Index: sasmodels/models/fractal_core_shell.py
===================================================================
--- sasmodels/models/fractal_core_shell.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/fractal_core_shell.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -1,42 +1,41 @@
 r"""
+Definition
+----------
 Calculates the scattering from a fractal structure with a primary building
 block of core-shell spheres, as opposed to just homogeneous spheres in
-the fractal model.
-This model could find use for aggregates of coated particles, or aggregates
-of vesicles.
-
-Definition
-----------
+the fractal model. It is an extension of the well known Teixeira\ [#teixeira]_
+fractal model replacing the $P(q)$ of a solid sphere with that of a core-shell
+sphere. This model could find use for aggregates of coated particles, or
+aggregates of vesicles for example.
 
 .. math::
 
-    I(q) = \text{background} + P(q)S(q)
+    I(q) = P(q)S(q) + \text{background}
 
-The form factor $P(q)$ is that from core_shell model with $bkg$ = 0
-
+Where $P(q)$ is the core-shell form factor and $S(q)$ is the
+Teixeira\ [#teixeira]_ fractal structure factor both of which are given again
+below:
 
 .. math::
 
-    P(q)=\frac{scale}{V_s}\left[3V_c(\rho_c-\rho_s)
+    P(q) &= \frac{\phi}{V_s}\left[3V_c(\rho_c-\rho_s)
     \frac{\sin(qr_c)-qr_c\cos(qr_c)}{(qr_c)^3}+
     3V_s(\rho_s-\rho_{solv})
     \frac{\sin(qr_s)-qr_s\cos(qr_s)}{(qr_s)^3}\right]^2
 
+    S(q) &= 1 + \frac{D_f\ \Gamma\!(D_f-1)}{[1+1/(q\xi)^2]^{(D_f-1)/2}} 
+    \frac{\sin[(D_f-1)\tan^{-1}(q\xi)]}{(qr_s)^{D_f}}
 
-while the fractal structure factor $S(q)$ is
+where $\phi$ is the volume fraction of particles, $V_s$ is the volume of the
+whole particle, $V_c$ is the volume of the core, $\rho_c$, $\rho_s$, and
+$\rho_{solv}$ are the scattering length densities of the core, shell, and
+solvent respectively, $r_c$ and $r_s$ are the radius of the core and the radius
+of the whole particle respectively, $D_f$ is the fractal dimension, and |xi| the
+correlation length.
+ 
+Polydispersity of radius and thickness are also provided for.
 
-.. math::
-
-    S(q) = \frac{D_f\Gamma(D_f-1)\sin((D_f-1)\tan^{-1}(q\xi))}
-    {(qr_c)^{D_f}\left(1+\frac{1}{q^2\xi ^2} \right)^{\frac{D_f-1}{2}}}
-
-where $D_f$ = fractal_dim, |xi| = cor_length, $r_c$ = (core) radius, and
-$scale$ = volume fraction.
-
-The fractal structure is as documented in the fractal model.
-Polydispersity of radius and thickness is provided for.
-
-For 2D data: The 2D scattering intensity is calculated in the same way as 1D,
-where the $q$ vector is defined as
+This model does not allow for anisotropy and thus the 2D scattering intensity
+is calculated in the same way as 1D, where the $q$ vector is defined as
 
 .. math::
@@ -44,8 +43,19 @@
     q = \sqrt{q_x^2 + q_y^2}
 
+Our model is derived from the form factor calculations implemented in IGOR
+macros by the NIST Center for Neutron Research\ [#Kline]_
+
 References
 ----------
 
-See the core_shell and fractal model descriptions
+.. [#teixeira] J Teixeira, *J. Appl. Cryst.*, 21 (1988) 781-785
+.. [#Kline]  S R Kline, *J Appl. Cryst.*, 39 (2006) 895
+
+Authorship and Verification
+----------------------------
+
+* **Author:** NIST IGOR/DANSE **Date:** pre 2010
+* **Last Modified by:** Paul Butler and Paul Kienzle **on:** November 27, 2016
+* **Last Reviewed by:** Paul Butler and Paul Kienzle **on:** November 27, 2016
 
 """
@@ -54,8 +64,19 @@
 
 name = "fractal_core_shell"
-title = ""
-description = """
+title = "Scattering from a fractal structure formed from core shell spheres"
+description = """\
+    Model for fractal aggregates of core-shell primary particles. It is based on
+    the Teixeira model for the S(q) of a fractal * P(q) for a core-shell sphere
 
-"""
+    radius =  the radius of the core
+    thickness = thickness of the shell
+    thick_layer = thickness of a layer
+    sld_core = the SLD of the core
+    sld_shell = the SLD of the shell
+    sld_solvent = the SLD of the solvent
+    volfraction = volume fraction of core-shell particles
+    fractal_dim = fractal dimension
+    cor_length = correlation length of the fractal like aggretates
+    """
 category = "shape-independent"
 
@@ -63,15 +84,17 @@
 #   ["name", "units", default, [lower, upper], "type","description"],
 parameters = [
-    ["radius",      "Ang",        60.0, [0, inf],    "volume", "Sphere core radius"],
-    ["thickness",   "Ang",        10.0, [0, inf],    "volume", "Sphere shell thickness"],
+    ["radius",      "Ang",        60.0, [0.0, inf],  "volume", "Sphere core radius"],
+    ["thickness",   "Ang",        10.0, [0.0, inf],  "volume", "Sphere shell thickness"],
     ["sld_core",    "1e-6/Ang^2", 1.0,  [-inf, inf], "sld",    "Sphere core scattering length density"],
     ["sld_shell",   "1e-6/Ang^2", 2.0,  [-inf, inf], "sld",    "Sphere shell scattering length density"],
     ["sld_solvent", "1e-6/Ang^2", 3.0,  [-inf, inf], "sld",    "Solvent scattering length density"],
-    ["volfraction", "",           1.0,  [0, inf],    "",       "Volume fraction of building block spheres"],
-    ["fractal_dim",    "",           2.0,  [-inf, inf], "",       "Fractal dimension"],
-    ["cor_length",  "Ang",      100.0,  [0, inf],    "",       "Correlation length of fractal-like aggregates"]]
+    ["volfraction", "",           1.0,  [0.0, inf],  "",       "Volume fraction of building block spheres"],
+    ["fractal_dim",    "",        2.0,  [0.0, 6.0],  "",       "Fractal dimension"],
+    ["cor_length",  "Ang",      100.0,  [0.0, inf],  "",       "Correlation length of fractal-like aggregates"],
+]
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/sas_gamma.c", "lib/core_shell.c", "fractal_core_shell.c"]
+source = ["lib/sas_3j1x_x.c", "lib/sas_gamma.c", "lib/core_shell.c",
+          "lib/fractal_sq.c", "fractal_core_shell.c"]
 
 demo = dict(scale=0.05,
@@ -100,17 +123,21 @@
         @param thickness: shell thickness
     """
-    whole = 4.0 * pi / 3.0 * pow((radius + thickness), 3)
-    core = 4.0 * pi / 3.0 * radius * radius * radius
+    whole = 4.0/3.0 * pi * (radius + thickness)**3
+    core = 4.0/3.0 * pi * radius**3
     return whole, whole-core
 
 tests = [[{'radius': 20.0, 'thickness': 10.0}, 'ER', 30.0],
-         [{'radius': 20.0, 'thickness': 10.0}, 'VR', 0.703703704],
+         [{'radius': 20.0, 'thickness': 10.0}, 'VR', 0.703703704]]
 
-         # The SasView test result was 0.00169, with a background of 0.001
-         [{'radius': 60.0,
-           'thickness': 10.0,
-           'sld_core': 1.0,
-           'sld_shell': 2.0,
-           'sld_solvent': 3.0,
-           'background': 0.0
-          }, 0.4, 0.00070126]]
+#         # The SasView test result was 0.00169, with a background of 0.001
+#         # They are however wrong as we now know.  IGOR might be a more
+#         # appropriate source. Otherwise will just have to assume this is now
+#         # correct and self generate a correct answer for the future. Until we
+#         # figure it out leave the tests commented out
+#         [{'radius': 60.0,
+#           'thickness': 10.0,
+#           'sld_core': 1.0,
+#           'sld_shell': 2.0,
+#           'sld_solvent': 3.0,
+#           'background': 0.0
+#          }, 0.015211, 692.84]]
Index: sasmodels/models/fuzzy_sphere.py
===================================================================
--- sasmodels/models/fuzzy_sphere.py	(revision 9a4811ac2bdb93459d640d111cba9f1016660790)
+++ sasmodels/models/fuzzy_sphere.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -81,15 +81,15 @@
 # pylint: enable=bad-whitespace,line-too-long
 
-source = ["lib/sph_j1c.c"]
+source = ["lib/sas_3j1x_x.c"]
 
 # No volume normalization despite having a volume parameter
 # This should perhaps be volume normalized?
 form_volume = """
-    return 1.333333333333333*M_PI*radius*radius*radius;
+    return M_4PI_3*cube(radius);
     """
 
 Iq = """
     const double qr = q*radius;
-    const double bes = sph_j1c(qr);
+    const double bes = sas_3j1x_x(qr);
     const double qf = q*fuzziness;
     const double fq = bes * (sld - sld_solvent) * form_volume(radius) * exp(-0.5*qf*qf);
